#include <windows.h>
#include <GdiPlus.h>

#pragma comment(lib,"GdiPlus.lib")

#define MYWNDCLASS		"Gdip07PathTransform"
#define MYWNDTITLE		"Gdip07PathTransform"

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;
GraphicsPath		*Path1 = NULL;

// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Draw_Image(HDC hDC, int width, int height);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, 480, 480,
				NULL,
				NULL,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int	width,height;
	
	switch (uMsg)
	{
	case WM_CREATE:
		GdiplusStartup(&gdiToken,&gdiSI,NULL);
		// pXIuWFNg̍쐬
		Path1 = new GraphicsPath();
		return 0;
	case WM_SIZE:
		width	= LOWORD(lParam);
		height	= HIWORD(lParam);
		return 0;
	case WM_PAINT:
		HDC			hDC;
		PAINTSTRUCT	ps;
		// `揀
		hDC = BeginPaint(hWnd,&ps);
		// 摜̕`
		Draw_Image(hDC, width, height);
		// `I
		EndPaint(hWnd,&ps);
		return 0;
	case WM_CLOSE:
		delete Path1;
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// 摜̕`
void Draw_Image(HDC hDC, int width, int height)
{
	// NCAg̈TCY̍Ɨprbg}bv쐬
	Bitmap bmpCp(width, height, PixelFormat32bppARGB);
	// Ɨprbg}bṽOtBbNIuWFNg쐬
	Graphics gBmp(&bmpCp);
	// Ɨprbg}bṽNbsO
	Rect rcBmp(0, 0, width, height);
	gBmp.SetClip(rcBmp);
	// pXP̍쐬ƕ`
	if(Path1){
		// pXP̍쐬Jn
		Path1->StartFigure();
		// pXPɒ`ǉ
		Rect rc1 = Rect(50, 50, 150, 50);
		Path1->AddRectangle(rc1);
		// pXP
		Path1->CloseFigure();
		// pXPΐFœhԂ
		SolidBrush brush1(Color(255,0,255,0));
		gBmp.FillPath(&brush1, Path1);
		// sIuWFNg̍쐬
		Matrix mtrx;
		// s(200, 0)ړǉ
		mtrx.Translate(200, 0);
		// s(125, 75)𒆐S45x]ǉ
		mtrx.RotateAt(45, PointF(25, 75));
		// sɏc0.5{ǉ
		mtrx.Scale(0.5f, 0.5f);
		// pXP̍sϊ
		Path1->Transform(&mtrx);
		// pXP𓍐FœhԂ
		SolidBrush brush2(Color(255,255,0,255));
		gBmp.FillPath(&brush2, Path1);
	}
	// NbsO
	gBmp.ResetClip();
	// foCXReLXg̃OtBbNIuWFNg쐬
	Graphics	g(hDC);
	// Ɨprbg}bvfoCXReLXg֕`
	g.DrawImage(&bmpCp, 0, 0, bmpCp.GetWidth(), bmpCp.GetHeight());
}// Draw_Image
